clear all; clc;

global h y_m y_mf tau A Kp Ti d SP

del_t=10; % timestep for integration
sim_time=25000; %total simulation time

A=2000; %area of Level tank
tau= input('Measurement time filter constant  '); %measurement filter time constant

%% Initial condition
h(1)=1;
y_m(1)=1;
y_mf(1)=1;
u=3*ones(1,sim_time/del_t);
d=3*ones(1,sim_time/del_t);
SP=1*ones(1,sim_time/del_t);

%% Cases
cho=menu('Choose a case','Step test','Change in Setpoint','Change in inflow');

if cho==1
    t = del_t:del_t:sim_time;  
    step = t>=15000;
    S_S=input('Step size for the change in out flow (-3 to 3) ');
    u=u+step*S_S;
end
   
if cho==2
    %PID control parameters (Skogestad tuning)
    Tc=input('enter the close-loop time constant for Skogestad method  ');
    K=1/A;
    c=2;
    Kp=1/(K*(tau+Tc));
    Ti=c*(Tc+tau);
    S_S=input('Step size for the change in setpoint (-1 to 1) ');
    t = del_t:del_t:sim_time;  
    step = t>=15000;
    SP=SP+step*S_S;
end

if cho==3
    %PID control parameters (Skogestad tuning)
    Tc=input('enter the close-loop time constant for Skogestad method  ');
    K=1/A;
    c=2;
    Kp=1/(K*(tau+Tc));
    Ti=c*(Tc+tau);
    t = del_t:del_t:sim_time;  
    step = t>=15000;
    S_S=input('Step size for the change in inflow (-3 to 3) ');
    d=d+step*S_S;
end

%% Run the model
y=model(cho, del_t, sim_time, tau,SP,u,d);

%% Plot the results
plot(y(2,:));
hold on
plot(SP,'--');
xlabel('Time (s)');
ylabel('Level (m)');
legend('Measured Level','Set Point');
axis([0 sim_time/del_t 0 2]);

figure

plot(d);
hold on
plot(y(3,:));
xlabel('Time (s)');
ylabel('Flow (m3/s)');
legend('F_i_n','F_o_u_t');
axis([0 sim_time/del_t 0 6])


 